using System;
using UnityEngine;
using UnityEngine.Events;
using System.Collections;
using System.Collections.Generic;

public class modlimb : MonoBehaviour
{
    public LimbBehaviour limb;
    public PersonBehaviour PB;
    private ContactPoint2D[] contactBuffer = new ContactPoint2D[8];

    void Awake()
    {
        limb = gameObject.GetComponent<LimbBehaviour>();
        //PB = transform.parent.parent.GetComponent<PersonBehaviour>();
        limb.CirculationBehaviour.BleedingRate *= 0.33f;
        limb.BloodMuscleStrengthRatio *= 0.65f;
        //limb.DrownTimeInSeconds = 45f;
    }
    void Shot(Shot shot)
    {
        if (UnityEngine.Random.Range(0f, 800f) < shot.damage)
        {
            limb.BreakBone();
        }
        if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
        {
            ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
            PB.GetComponent<modperson>().brainDmgMultiplier += shot.damage / 100f; 
        }
        string a = gameObject.name;
        if (a == "UpperBody" || a == "MiddleBody" && UnityEngine.Random.Range(0f, 1f) > 0.25f)
        {
            PB.GetComponent<modperson>().heartHealth -= 0.5f;
            PB.GetComponent<modperson>().lungHealth -= 0.2f;
            PB.GetComponent<modperson>().lungHealthLossRate += 0.003f;
        }
        if(a == "MiddleBody")
        {
            PB.GetComponent<modperson>().liverHealth -= 0.3f;
        }
    }
    void Stabbed(Stabbing stabbing)
    {
        string a = gameObject.name;
        if (a == "UpperBody" || a == "MiddleBody" && UnityEngine.Random.Range(0f, 1f) > 0.25f)
        {
            PB.GetComponent<modperson>().heartHealth -= 0.34f;
            PB.GetComponent<modperson>().lungHealth -= 0.34f;
            PB.GetComponent<modperson>().lungHealthLossRate += 0.004f;
        }
        if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
        {
            //ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
            PB.GetComponent<modperson>().brainDmgMultiplier += 1f;
        }
    }
    void Repair()
    {
        if (limb.RoughClassification == LimbBehaviour.BodyPart.Head)
        {
            PB.GetComponent<modperson>().brainDmgMultiplier = 0f;
        }
    }
    void OnCollisionEnter2D(Collision2D collision)
    {
        //0.75f is a good value for a damaging hit
        float impulse = 0f;
        foreach (ContactPoint2D point in collision.contacts)
        {
            impulse += point.normalImpulse;
        }
        if(limb.RoughClassification == LimbBehaviour.BodyPart.Head && impulse > 0.75f && UnityEngine.Random.Range(0f, 1f) > 0.5f)
        {
            print(PB.gameObject.GetComponent<modperson>());
            PB.GetComponent<modperson>().brainDmgMultiplier += impulse / 3.5f;
        }
    }
    void Update()
    {
        /*if(Input.GetKey(KeyCode.R))
        {
            limb.Wince(2000f);
            print("a");
        }*/
    }
    void FixedUpdate()
    {
        if(limb.Broken)
        {
            string a = limb.gameObject.name;
            if (a == "Head" || a == "UpperBody" || a == "MiddleBody" || a == "LowerBody")
            {
                //ModAPI.Notify("penis");
                PB.Limbs[6].Numbness = 999f;
                PB.Limbs[7].Numbness = 999f;
                PB.Limbs[5].Numbness = 999f;
                PB.Limbs[4].Numbness = 999f;
                PB.Limbs[8].Numbness = 999f;
                PB.Limbs[9].Numbness = 999f;
            }
        }
    }
}
